/*
 * CG Madness - a Marble Madness clone
 * Copyright (C) 2007  Sven Reinck <sreinck@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#ifndef _portal_hpp_
#define _portal_hpp_

#include "vector.hpp"
#include "quaternion.hpp"

#define PORTAL_RADIUS 0.48f

typedef struct Portal
{
	Vector3 pos;
	Quaternion orientation;
	struct Portal *other;
} Portal;


void initPortal(Portal * portal);

void addPortal(Portal * portal);

void renderPortals(void (*drawObjects) (void));

#endif
